library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.ALL;

entity vga_led is
port(
  clk50_in  : in std_logic;
  hs_out    : out std_logic;
  vs_out    : out std_logic;
  
  red_out   : OUT STD_LOGIC_VECTOR(3 downto 0);
  green_out : OUT STD_LOGIC_VECTOR(3 downto 0);
  blue_out  : OUT STD_LOGIC_VECTOR(3 downto 0);
	
	switch    :  in std_logic_vector(9 downto 0);
	key       :  in std_logic_vector(3 downto 0)
  ); 
end vga_led;

architecture behavioral of vga_led is

signal clk25    : std_logic:='0';
signal hcounter : unsigned (9 downto 0):=to_unsigned(0,10);
signal vcounter : unsigned (9 downto 0):=to_unsigned(0,10);

begin

-- generate a 25Mhz clock
process (clk50_in)
begin
  if clk50_in'event and clk50_in='1' then
    clk25 <= not clk25;
  end if;
end process;

process (clk25)
begin
  if clk25'event and clk25 = '1' then
    if (vcounter >=20 and vcounter < 40)then
      if ((hcounter>= 20 and hcounter < 35) and (Switch(0) ='1')) then
        red_out<="1000";
      end if;
			if (hcounter >=  35 and hcounter < 45) then
        red_out<="0000";
      end if;
			
			if ((hcounter >=  45 and hcounter < 60) and (Switch(1) ='1')) then
        red_out<="1000";
      end if;
			if (hcounter >=  60 and hcounter < 70) then
        red_out<="0000";
      end if;	
			
			if ((hcounter >=  70 and hcounter < 85) and (Switch(02) ='1')) then
        red_out<="1000";
      end if;
			if (hcounter >=  85 and hcounter < 95) then
        red_out<="0000";
      end if;
			
			if ((hcounter >=  95 and hcounter < 110) and (Switch(3) ='1')) then
        red_out<="1000";
      end if;
			if (hcounter >=  110 and hcounter < 120) then
        red_out<="0000";
      end if;
			
			if ((hcounter >=  120 and hcounter < 135) and (Switch(4) ='1')) then
        red_out<="1000";
      end if;
			if (hcounter >=  135 and hcounter < 145) then
        red_out<="0000";
      end if;	
			
			if ((hcounter >=  145 and hcounter < 160) and (Switch(5) ='1')) then
        red_out<="1000";
      end if;
			if (hcounter >=  160 and hcounter < 170) then
        red_out<="0000";
      end if;
			
			if ((hcounter >=  170 and hcounter < 185) and (Switch(6) ='1')) then
        red_out<="1000";
      end if;
			if (hcounter >=  185 and hcounter < 195) then
        red_out<="0000";
      end if;	
			
			if ((hcounter >=  195 and hcounter < 210) and (Switch(7) ='1')) then
        red_out<="1000";
      end if;
			if (hcounter >=  210 and hcounter < 220) then
        red_out<="0000";
      end if;
			
			if ((hcounter >=  220 and hcounter < 235) and (Switch(8) ='1')) then
        red_out<="1000";
      end if;
			if (hcounter >=  235 and hcounter < 245) then
        red_out<="0000";
      end if;
			
			if ((hcounter >=  245 and hcounter < 260) and (Switch(9) ='1')) then
        red_out<="1000";
      end if;
			if (hcounter >=  260 and hcounter < 640) then
        red_out<="0000";
      end if;	
    end if;
  end if;
end process;

process (clk25)
begin
  if clk25'event and clk25 = '1' then
    if (vcounter >=60 and vcounter < 80) then
      if ((hcounter >=  20 and hcounter < 35) and (key(0) ='0')) then
        green_out<="1000";
      end if;
			if (hcounter >=  35 and hcounter < 45) then
        green_out<="0000";
      end if;
			
			if ((hcounter >=  45 and hcounter < 60) and (key(1) ='0')) then
        green_out<="1000";
      end if;
			if (hcounter >=  60 and hcounter < 70) then
        green_out<="0000";
      end if;	
			
			if ((hcounter >=  70 and hcounter < 85) and (key(2) ='0')) then
        green_out<="1000";
      end if;
			if (hcounter >=  85 and hcounter < 95) then
        green_out<="0000";
      end if;
			
			if ((hcounter >=  95 and hcounter < 110) and (key(3) ='0')) then
        green_out<="1000";
      end if;
			if (hcounter >=  110 and hcounter < 640) then
        green_out<="0000";
      end if;
    end if;
  end if;
end process;

process (clk25)
begin
  if clk25'event and clk25 = '1' then
    if hcounter >= (639+16) and hcounter <= (639+16+96) then
      hs_out <= '0';
    else
      hs_out <= '1';
    end if;
  
    if vcounter >= (479+10) and vcounter <= (479+10+2) then
      vs_out <= '0';
     else
      vs_out <= '1';
    end if;
  
--- horizontal counts from 0 to 799
    hcounter <= hcounter+1;
  
    if hcounter = 799 then
      vcounter <= vcounter+1;
      hcounter <= to_unsigned(0,10);
    end if;
  
--- vertical counts from 0 to 524
    if vcounter = 524 then 
      vcounter <= to_unsigned(0,10);
    end if;
  end if;
end process;

end behavioral;